﻿Imports System.Data.SqlClient
Imports System.Data
Imports Telerik.Web.UI

Partial Class ListViewVB
    Inherits System.Web.UI.Page

    Public _connString As String = ConfigurationManager.ConnectionStrings("NorthwindConnectionString").ConnectionString

    Protected Sub RadListView1_ItemUpdating(sender As Object, e As RadListViewCommandEventArgs)
        Dim editedItem As RadListViewEditableItem = DirectCast(e.ListViewItem, RadListViewEditableItem)
        Dim MyUserControl As UserControl = CType(editedItem.Controls(1), UserControl)
        Dim newValues As New Hashtable()

        Dim productsTable As DataTable = RadListViewSource
        'Locate the changed row in the DataSource
        Dim changedRows As DataRow() = productsTable.[Select]("ProductID = " + editedItem.GetDataKeyValue("ProductID").ToString())
        If changedRows.Length <> 1 Then
            e.Canceled = True
            Return
        End If

        newValues("ProductName") = CType(MyUserControl.FindControl("TextBox1"), TextBox).Text
        newValues("QuantityPerUnit") = CType(MyUserControl.FindControl("TextBox2"), TextBox).Text
        newValues("UnitPrice") = CType(MyUserControl.FindControl("TextBox3"), TextBox).Text
        newValues("UnitsInStock") = CType(MyUserControl.FindControl("TextBox4"), TextBox).Text
        newValues("Discontinued") = CType(MyUserControl.FindControl("CheckBox1"), CheckBox).Checked.ToString()
       


        'Update new values
        changedRows(0).BeginEdit()
        Try
            For Each entry As DictionaryEntry In newValues
                changedRows(0)(DirectCast(entry.Key, String)) = entry.Value
            Next
            changedRows(0).EndEdit()
            Me.ViewState("_lvds") = productsTable
        Catch ex As Exception
            changedRows(0).CancelEdit()
            'output a warning message as necessary
            e.Canceled = True
            ShowStatus(ex.Message)
        End Try
    End Sub

    Private Sub ShowStatus(message As String)
        StatusLabel.Style("display") = String.Empty
        StatusLabel.Text = message
    End Sub

    Protected Sub RadListView1_NeedDataSource(sender As Object, e As RadListViewNeedDataSourceEventArgs)
        RadListView1.DataSource = RadListViewSource
    End Sub

    Protected Sub RadListView1_ItemInserting(sender As Object, e As RadListViewCommandEventArgs)
        Dim insertedItem As RadListViewEditableItem = DirectCast(e.ListViewItem, RadListViewEditableItem)
        Dim MyUserControl As UserControl = CType(editedItem.Controls(1), UserControl)
        Dim newValues As New Hashtable()

        newValues("ProductName") = CType(MyUserControl.FindControl("TextBox1"), TextBox).Text
        newValues("QuantityPerUnit") = CType(MyUserControl.FindControl("TextBox2"), TextBox).Text
        newValues("UnitPrice") = CType(MyUserControl.FindControl("TextBox3"), TextBox).Text
        newValues("UnitsInStock") = CType(MyUserControl.FindControl("TextBox4"), TextBox).Text
        newValues("Discontinued") = CType(MyUserControl.FindControl("CheckBox1"), CheckBox).Checked.ToString()

        Dim productsTable As DataTable = RadListViewSource

        Dim newRow As DataRow = productsTable.NewRow()
        Try
            newRow("ProductID") = productsTable.Rows.Count + 1
            For Each entry As DictionaryEntry In newValues
                newRow(DirectCast(entry.Key, String)) = entry.Value
            Next
            productsTable.Rows.Add(newRow)
            Me.ViewState("_lvds") = productsTable
        Catch ex As Exception
            'output a warning message as necessary
            ShowStatus(ex.Message)
            e.Canceled = True
        End Try
    End Sub

    Protected Sub RadListView1_ItemDeleting(sender As Object, e As RadListViewCommandEventArgs)
        Try
            Dim productsTable As DataTable = Me.RadListViewSource

            Dim pk As DataColumn = productsTable.Columns("ProductID")
            Dim pkeys As DataColumn() = New DataColumn(0) {}
            pkeys(0) = pk
            productsTable.PrimaryKey = pkeys

            Dim id As Integer = Integer.Parse(e.CommandArgument.ToString())

            productsTable.Rows.Find(id).Delete()
            productsTable.AcceptChanges()
            Me.ViewState("_lvds") = productsTable
        Catch ex As Exception
            'output a warning message as necessary
            ShowStatus(ex.Message)
            e.Canceled = True
        End Try
    End Sub

    Private ReadOnly Property RadListViewSource() As DataTable
        Get
            Dim obj As [Object] = ViewState("_lvds")
            If obj IsNot Nothing Then
                Return DirectCast(obj, DataTable)
            Else
                Dim listViewDataSource As DataTable
                Using sqlConnection1 As New SqlConnection(_connString)
                    listViewDataSource = New DataTable()
                    'Select Query to populate the RadGrid with data from table Customers.
                    Const selectQuery As String = "SELECT * FROM [Products]"
                    Using sqlDataAdapter As New SqlDataAdapter()
                        sqlDataAdapter.SelectCommand = New SqlCommand(selectQuery, sqlConnection1)
                        sqlDataAdapter.Fill(listViewDataSource)
                    End Using
                End Using
                ViewState("_lvds") = listViewDataSource
                Return listViewDataSource
            End If
        End Get
    End Property


End Class
